#line 22 "trail.nw"
#if !COPY_SEARCH_SPACE
typedef struct save_rec {
    word	 *addr;		/* address of updated node */
    word	 info;		/* old info vector */
    unsigned int ofs;		/* offset within node */
    word	 val;		/* saved value */
} SaveRec;
#endif

#line 39 "trail.nw"
#if !COPY_SEARCH_SPACE
extern SaveRec *trail_base, *trail_end;

extern void trail_overflow(void) __attribute__((noreturn));

#define CHECK_TRAIL1()	if ( regs.tp >= trail_end ) trail_overflow();
#define CHECK_TRAIL(n)	if ( regs.tp + (n) > trail_end ) trail_overflow();
#endif

#line 80 "trail.nw"
#if !COPY_SEARCH_SPACE
extern void init_trail(unsigned int trail_size);
#endif

#line 120 "trail.nw"
#if !COPY_SEARCH_SPACE
#define INFO_OFS	word_offsetof(Node, info)

#define DO_SAVE(v,f) do {				\
	CHECK_TRAIL1();					\
	regs.tp->addr = (word *)(v);			\
	regs.tp->info = regs.tp->addr[INFO_OFS];	\
	regs.tp->ofs  = (word *)&(v->f) - (word *)(v);	\
	regs.tp->val  = (word)(v->f);			\
	regs.tp++;					\
    } while (0)
#define SAVE(v,f) do {						     \
	if ( (word *)(v) < regs.hlim && (word *)(v->f) < regs.hlim ) \
	    DO_SAVE(v,f);					     \
    } while (0)
#else
# define DO_SAVE(v,f)  /* empty */
# define SAVE(v,f)     /* empty */
#endif

#line 148 "trail.nw"
#if !COPY_SEARCH_SPACE
#define RESTORE(oldTp) do {				 \
	while ( regs.tp > oldTp ) {			 \
	    --regs.tp;					 \
	    regs.tp->addr[INFO_OFS]	= regs.tp->info; \
	    regs.tp->addr[regs.tp->ofs] = regs.tp->val;	 \
	}						 \
    } while (0)
#endif
